diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryBoat.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryBoat.java
index 8f6299068..662441755 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryBoat.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryBoat.java
@@ -5,21 +5,21 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityEntryBoat extends EntityEntry<BoatEntity>{
+public class EntityEntryBoat extends EntityEntry<EntityBoat>{
     @Override
-    public void onTick(BoatEntity entity) {
+    public void onTick(EntityBoat entity) {
 
     }
 
     @Override
-    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, BoatEntity entity) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, EntityBoat entity) {
         ListenerButtonElement flagButton = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.boat.button.flag", false));
         flagButton.setActionListener(() -> {
             boolean flag;
@@ -36,8 +36,8 @@ public class EntityEntryBoat extends EntityEntry<BoatEntity>{
     }
 
     @Override
-    public BoatEntity getEntityInstance(Minecraft mc, World world) {
-        BoatEntity boat = new BoatEntity(world);
+    public EntityBoat getEntityInstance(Minecraft mc, World world) {
+        EntityBoat boat = new EntityBoat(world);
         boat.yRot = 270f;
         boat.zd = 100; // Causes the flag to rotate when enabled
         return boat;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java
index fcb9ba12f..1e2815803 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java
@@ -26,7 +26,7 @@ public class EntityEntryDispatcher extends EntityEntry<Entity> {
 
     @Override
     public Entity getEntityInstance(Minecraft mc, World world) {
-        return EntityDispatcher.createEntityInWorld(id, mc.theWorld);
+        return EntityDispatcher.createEntityInWorld(id, mc.currentWorld);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryRedstone.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryRedstone.java
index 68177a69a..e7b66dc25 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryRedstone.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryRedstone.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.particle.ParticleRedstoneDust;
+import net.minecraft.client.entity.particle.ParticlePuffRGB;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
@@ -71,7 +71,7 @@ public class ParticleEntryRedstone extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.particleEngine.add(new ParticleRedstoneDust(world, x, y, z, red/255f, green/255f, blue/255f, 15));
+        mc.particleEngine.add(new ParticlePuffRGB(world, x, y, z, red/255f, green/255f, blue/255f, 15));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java b/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
index 329332f54..fd518d2ea 100644
--- a/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
+++ b/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
@@ -250,7 +250,7 @@ public class OptionsScreen
         Scissor.disable();
 
         // Draw shadows
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             GL11.glDisable(GL_DEPTH_TEST);
@@ -469,7 +469,7 @@ public class OptionsScreen
     public void renderBackground() {
         super.renderBackground();
 
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
@@ -500,7 +500,7 @@ public class OptionsScreen
 
     private void overlayBackground(int minX, int maxX, int minY, int maxY)
     {
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
diff --git a/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
index eb61a2982..62ced22b3 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
@@ -59,7 +59,7 @@ public class DifficultyOptionComponent extends ButtonComponent {
             return;
         }
         slider.enabled = true;
-        option.set(mc.theWorld.getDifficulty());
+        option.set(mc.currentWorld.getDifficulty());
         slider.sliderValue = option.value.id();
         this.slider.displayString = getDisplayString();
     }
@@ -67,14 +67,14 @@ public class DifficultyOptionComponent extends ButtonComponent {
     @Override
     public void resetValue() {
         if (canSetDifficulty()) {
-            mc.theWorld.setDifficulty(Difficulty.NORMAL, false);
+            mc.currentWorld.setDifficulty(Difficulty.NORMAL, false);
         }
     }
 
     @Override
     public boolean isDefault() {
         boolean canSet = canSetDifficulty();
-        return !canSet || mc.theWorld.getDifficulty() == Difficulty.NORMAL;
+        return !canSet || mc.currentWorld.getDifficulty() == Difficulty.NORMAL;
     }
     protected String getDisplayString() {
         if (!canSetDifficulty()) {
@@ -84,6 +84,6 @@ public class DifficultyOptionComponent extends ButtonComponent {
     }
 
     protected boolean canSetDifficulty() {
-        return mc.theWorld != null && !mc.theWorld.getLevelData().getDifficultyLocked() && !mc.theWorld.isClientSide;
+        return mc.currentWorld != null && !mc.currentWorld.getLevelData().getDifficultyLocked() && !mc.currentWorld.isClientSide;
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 9c6b6bc4f..c3cb902a2 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -24,6 +24,7 @@ import net.minecraft.client.gui.options.components.ToggleableOptionComponent;
 import net.minecraft.client.gui.options.components.TooltipPickerComponent;
 import net.minecraft.client.player.controller.PlayerControllerSP;
 import net.minecraft.client.sound.SoundEngine;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
@@ -285,11 +286,11 @@ public abstract class OptionsPages
         .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
                                mc.playerController = new PlayerControllerSP(mc);
-                               mc.changeWorld(new World(), "Loading Model Viewer");
+                               mc.changeWorld(new WorldClient(), "Loading Model Viewer");
                                mc.displayScreen(new ScreenModelViewer());}) {
                                @Override
                                public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-                                   button.enabled = mc.theWorld == null;
+                                   button.enabled = mc.currentWorld == null;
                                    super.render(x, y, width, relativeMouseX, relativeMouseY);
                                }
                            }
@@ -317,11 +318,11 @@ public abstract class OptionsPages
                 mc.sndManager.tick();
             }))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.cheat", () -> {
-                mc.theWorld.getLevelData().setCheatsEnabled(true);
+                mc.currentWorld.getLevelData().setCheatsEnabled(true);
             }) {
                 @Override
                 public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-                    button.enabled = (mc.theWorld != null && !mc.theWorld.isClientSide);
+                    button.enabled = (mc.currentWorld != null && !mc.currentWorld.isClientSide);
                     super.render(x, y, width, relativeMouseX, relativeMouseY);
                 }
             })
diff --git a/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java b/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
index cf5170875..06cc0f60f 100644
--- a/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
+++ b/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
@@ -221,7 +221,7 @@ public class ScreenPaged
         Scissor.disable();
 
         // Draw shadows
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             GL11.glDisable(GL_DEPTH_TEST);
@@ -424,7 +424,7 @@ public class ScreenPaged
     public void renderBackground() {
         super.renderBackground();
 
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
@@ -455,7 +455,7 @@ public class ScreenPaged
 
     private void overlayBackground(int minX, int maxX, int minY, int maxY)
     {
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
diff --git a/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
index 1e7bd56a2..424218f0e 100644
--- a/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
+++ b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.net.command;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.helpers.EntitySelector;
@@ -24,7 +25,7 @@ public class ClientCommandSource implements CommandSource {
     @Override
     public Collection<String> getPlayerNames() {
         List<String> list = new ArrayList<>();
-        for (Player player : this.mc.theWorld.players) {
+        for (Player player : this.mc.currentWorld.players) {
             list.add(player.username);
         }
         return list;
@@ -94,12 +95,12 @@ public class ClientCommandSource implements CommandSource {
 
     @Override
     public World getWorld() {
-        return this.mc.theWorld;
+        return this.mc.currentWorld;
     }
 
     @Override
     public World getWorld(int dimension) {
-        return this.mc.theWorld.dimension.id == dimension ? this.mc.theWorld : new World(this.mc.theWorld, Dimension.getDimensionList().get(dimension));
+        return this.mc.currentWorld.dimension.id == dimension ? this.mc.currentWorld : new World(this.mc.currentWorld, Dimension.getDimensionList().get(dimension));
     }
 
     public void movePlayerToDimension(Player player, int dimension) {
@@ -107,25 +108,25 @@ public class ClientCommandSource implements CommandSource {
         Dimension newDim = Dimension.getDimensionList().get(dimension);
         System.out.println("Switching to dimension \"" + newDim.getTranslatedName() + "\"!!");
         player.dimension = dimension;
-        this.mc.theWorld.setEntityDead(player);
+        this.mc.currentWorld.setEntityDead(player);
         this.mc.thePlayer.removed = false;
         double x = player.x;
         double y = player.y + 64;
         double z = player.z;
         player.moveTo(x *= Dimension.getCoordScale(lastDim, newDim), y, z *= Dimension.getCoordScale(lastDim, newDim), player.yRot, player.xRot);
         if (player.isAlive()) {
-            this.mc.theWorld.updateEntityWithOptionalForce(player, false);
+            this.mc.currentWorld.updateEntityWithOptionalForce(player, false);
         }
-        World world = new World(this.mc.theWorld, newDim);
+        WorldClient world = new WorldClient(this.mc.currentWorld, newDim);
         if (newDim == lastDim.homeDim) {
             this.mc.changeWorld(world, "Leaving " + lastDim.getTranslatedName(), player);
         } else {
             this.mc.changeWorld(world, "Entering " + newDim.getTranslatedName(), player);
         }
-        player.world = this.mc.theWorld;
+        player.world = this.mc.currentWorld;
         if (player.isAlive()) {
             player.moveTo(x, y, z, player.yRot, player.xRot);
-            this.mc.theWorld.updateEntityWithOptionalForce(player, false);
+            this.mc.currentWorld.updateEntityWithOptionalForce(player, false);
         }
     }
 
